'Beautify Directory
'BeautifyDirectory.bas

#INCLUDE ONCE "vbcompat.bi"
#INCLUDE ONCE "dir.bi"

'#DEFINE DELETE_OLD_FILES
#INCLUDE "Functions.bas"
#INCLUDE "Path.bas"

TYPE tFile
  s AS STRING
  i AS INTEGER
  DECLARE SUB Set(AS STRING)
END TYPE

DECLARE FUNCTION optionName(opt AS STRING) AS STRING

' FBeauty.exe is assumed to be in the program directory. If it is elsewhere, the
' full file name must be provided, e.g. "C:\FBeautyFolder\FBeauty.exe".

CONST FBeauty = "FBeauty.exe" ' <--
CONST optUpCase      = ""
CONST optLowCase     = "-l"
CONST optCapitalized = "-c"
CONST optIndividual  = "-i"

SUB procedure(aFilterOption AS CONST STRING=optUpCase)
  DIM AS STRING filterOption = aFilterOption
  DIM AS STRING d1(), d2(), s, a_line = STRING(80, "-")
  DIM AS STRING sPathStatus(noSource) = {"noError", "doesntExist", "noSource"}
  DIM AS INTEGER n, o
  DIM AS tFile fLog, fDir
  DIM AS tPathStatus st

  CHDIR(EXEPATH())
  
  fLog.Set("Log.txt")
  
  OPEN fLog.s FOR OUTPUT AS #fLog.i
  
  PRINT #fLog.i, a_line
  PRINT #fLog.i, "Date : " & FORMAT(NOW, "ddddd" )
  PRINT #fLog.i, a_line
  PRINT #fLog.i, "BeautifyDirectory is running."
  PRINT #fLog.i, "Time : " & FORMAT(NOW, "hh:mm:ss")
  PRINT #fLog.i, a_line
  
  fDir.Set("Directories.cfg")
  
  IF FILEEXISTS(fDir.s) THEN
    PRINT #fLog.i, fDir.s & " found."
    PRINT #fLog.i, a_line
    OPEN fDir.s FOR INPUT AS #fDir.i
    n = 0
    DO UNTIL EOF(fDir.i)
    LINE INPUT #fDir.i, s
    IF LEN(s) > 0 THEN
      PRINT #fLog.i, s
      REDIM PRESERVE d1(n) AS STRING
      d1(n) = s
      n += 1
    END IF
    LOOP
    CLOSE #fDir.i
  ELSE
    PRINT #fLog.i, fDir.s & " not found."
    PRINT #fLog.i, a_line
    PRINT #fLog.i, "BeautifyDirectory stops."
    PRINT #fLog.i, a_line
    CLOSE #fLog.i
    END
  END IF
  PRINT #fLog.i, a_line
  
  FOR n = 0 TO UBOUND(d1)
    PRINT #fLog.i, "[" & n & "]" & d1(n)
  NEXT n
  PRINT #fLog.i, a_line
  
  o = 0
  FOR n = 0 TO UBOUND(d1)
    st = fPathStatus(d1(n))
    SELECT CASE st
    CASE noError
    PRINT #fLog.i, "[" & n & "]status=" & sPathStatus(st)
    REDIM PRESERVE d2(o) AS STRING
    d2(o) = d1(n)
    o += 1
    CASE doesntExist
    PRINT #fLog.i, "[" & n & "]status=" & sPathStatus(st)
    CASE noSource
    PRINT #fLog.i, "[" & n & "]status=" & sPathStatus(st)
    END SELECT
  NEXT n
  PRINT #fLog.i, a_line
  
  IF o = 0 THEN
    PRINT #fLog.i, "Valid directory not found."
    PRINT #fLog.i, a_line
    PRINT #fLog.i, "BeautifyDirectory stops."
    PRINT #fLog.i, a_line
    CLOSE #fLog.i
    END
  ELSE
    PRINT #fLog.i, "Valid directory found."
    PRINT #fLog.i, "Time : " & FORMAT(NOW, "hh:mm:ss")
    PRINT #fLog.i, a_line
  END IF
  
  FOR n = 0 TO UBOUND(d2)
    PRINT #fLog.i, "[" & n & "]" & d2(n)
  NEXT n
  PRINT #fLog.i, a_line
  
  IF (filterOption = optUpCase)_
  OR (filterOption = optLowCase)_
  OR (filterOption = optCapitalized)_
  OR (filterOption = optIndividual) THEN
    REM
  ELSE
    filterOption = optUpCase
  END IF
  
  PRINT #fLog.i, "Filter option : " & optionName(filterOption)
  PRINT #fLog.i, a_line
  
  IF FILEEXISTS(FBeauty) THEN
    PRINT #fLog.i, FBeauty & " found."
    PRINT #fLog.i, "Time : " & FORMAT(NOW, "hh:mm:ss")
    PRINT #fLog.i, a_line
    CLOSE #fLog.i
    FOR n = 0 TO UBOUND(d2)
    beautify(FBeauty, d2(n), filterOption)
    NEXT n
    fLog.Set("Log.txt")
    OPEN fLog.s FOR APPEND AS #fLog.i
    PRINT #fLog.i, "Done."
    PRINT #fLog.i, "Time : " & FORMAT(NOW, "hh:mm:ss")
    PRINT #fLog.i, a_line
  ELSE
    PRINT #fLog.i, FBeauty & " not found."
    PRINT #fLog.i, a_line
  END IF
  
  PRINT #fLog.i, "BeautifyDirectory stops."
  PRINT #fLog.i, a_line
  CLOSE #fLog.i
END SUB ' procedure

SUB tFile.Set(args AS STRING)
  this.s = args
  this.i = FREEFILE
END SUB

FUNCTION optionName(opt AS STRING) AS STRING
  SELECT CASE opt
  CASE optUpCase
    RETURN "upper case"
  CASE optLowCase
    RETURN "lower case keywords"
  CASE optCapitalized
    RETURN "capitalized keywords"
  CASE optIndividual
    RETURN "individual keywords"
  CASE ELSE
    RETURN "unknown"
  END SELECT
END FUNCTION

' 31 juillet 2013
