'Beautify Directory
'Functions.bas

#INCLUDE ONCE "dir.bi"

FUNCTION changeFileExt(fil AS STRING, ext AS STRING) AS STRING
  DIM s AS STRING
  DIM i AS INTEGER = LEN(fil)
  IF INSTR(fil, ".") = 0 THEN
    RETURN fil & ext
  ELSE
    DO UNTIL fil[i-1] = ASC(".")
      i -= 1
    LOOP
    RETURN LEFT(fil, i) & ext
  END IF
END FUNCTION

SUB generateFile(src AS STRING, dst AS STRING, flt AS STRING, opt AS STRING)
  DIM s AS STRING
  OPEN dst FOR OUTPUT AS #1
  OPEN PIPE flt & " " & opt & " < " & src FOR INPUT AS #2
  DO UNTIL EOF(2)
    LINE INPUT #2, s
    PRINT #1, s
  LOOP
  CLOSE #2
  CLOSE #1
END SUB

SUB getExt(pth AS STRING, ext AS STRING, a() AS STRING)
  DIM s AS STRING
  DIM i AS INTEGER=0
  s = DIR(pth & "*." & ext, fbArchive)
  DO WHILE LEN(s)
    REDIM PRESERVE a(i) AS STRING
    a(i) = s
    i += 1
    s = DIR()                   
  LOOP
END SUB

SUB replaceExt(pth AS STRING, old AS STRING, ext AS STRING)
  DIM s AS STRING
  s = DIR(pth & "*." & old, fbArchive)
  DO WHILE LEN(s)
    NAME(pth & s, pth & changeFileExt(s, ext))
    s = DIR()
  LOOP
END SUB

SUB deleteExt(pth AS STRING, ext AS STRING)
  DIM s AS STRING
  s = DIR(pth & "*." & ext, fbArchive)
  DO WHILE LEN(s)
    KILL(pth & s)
    s = DIR()
  LOOP  
END SUB

SUB beautify(flt AS STRING, pth AS STRING, opt AS STRING)
  CONST bas  = "bas"
  CONST bi   = "bi"
  CONST temp = "~bas"
  DIM array() AS STRING
  replaceExt(pth, bas, temp)
  getExt(pth, temp, array())
  FOR i AS INTEGER = LBOUND(array) TO UBOUND(array)
    generateFile(pth & array(i), pth & changeFileExt(array(i), bas), flt, opt)
  NEXT i
#IFDEF DELETE_OLD_FILES
  deleteExt(pth, temp)
#ENDIF
END SUB




